Index: /LMDZ6/trunk/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 3887)
+++ /LMDZ6/trunk/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 3888)
@@ -814,6 +814,4 @@
 'flat_w', 'flat within_wake', 'W/m2', (/ ('', i=1, 10) /))
 !!
-  type(ctrl_out),save :: o_delta_tsurf    = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
-'delta_tsurf', 'Temperature difference (w-x)', 'K', (/ ('', i=1, 10) /))
   type(ctrl_out),save :: o_cdragh_x       = ctrl_out((/ 1, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
 'cdragh_x', 'cdragh off-wake', '', (/ ('', i=1, 10) /))
@@ -1094,4 +1092,16 @@
       ctrl_out((/ 10, 4, 10, 10, 10, 10, 11, 11, 11, 11/),'dltpbltke_sic',       &
       "TKE difference (w - x) "//clnsurf(4),"-", (/ ('', i=1, 10) /)) /)
+
+  TYPE(ctrl_out), SAVE :: o_delta_tsurf = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
+    'delta_tsurf ', 'T_surf difference (w - x)', 'K', (/ ('', i=1, 10) /))
+  TYPE(ctrl_out), SAVE, DIMENSION(4) :: o_delta_tsurf_srf      = (/             &
+      ctrl_out((/ 10, 4, 10, 10, 10, 10, 11, 11, 11, 11/),'delta_tsurf_ter',       &
+      "T_surf difference (w - x) "//clnsurf(1),"-", (/ ('', i=1, 10) /)), &
+      ctrl_out((/ 10, 4, 10, 10, 10, 10, 11, 11, 11, 11/),'delta_tsurf_lic',       &
+      "T_surf difference (w - x) "//clnsurf(2),"-", (/ ('', i=1, 10) /)), &
+      ctrl_out((/ 10, 4, 10, 10, 10, 10, 11, 11, 11, 11/),'delta_tsurf_oce',       &
+      "T_surf difference (w - x) "//clnsurf(3),"-", (/ ('', i=1, 10) /)), &
+      ctrl_out((/ 10, 4, 10, 10, 10, 10, 11, 11, 11, 11/),'delta_tsurf_sic',       &
+      "T_surf difference (w - x) "//clnsurf(4),"-", (/ ('', i=1, 10) /)) /)
 
   TYPE(ctrl_out), SAVE :: o_kz = ctrl_out((/ 4, 10, 10, 10, 10, 10, 11, 11, 11, 11/), &
Index: /LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 3887)
+++ /LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 3888)
@@ -87,5 +87,5 @@
          o_dtvdf_x    , o_dtvdf_w    , o_dqvdf_x    , o_dqvdf_w    , &
          o_sens_x     , o_sens_w     , o_flat_x     , o_flat_w     , &
-         o_delta_tsurf, &
+         o_delta_tsurf, o_delta_tsurf_srf, &
          o_cdragh_x   , o_cdragh_w   , o_cdragm_x   , o_cdragm_w   , &
          o_kh         , o_kh_x       , o_kh_w       , &
@@ -1354,9 +1354,18 @@
 !
                CALL histwrite_phy(o_dqvdf_w    ,zx_tmp_fi3d) 
-               CALL histwrite_phy(o_sens_x     ,sens_x     ) 
-               CALL histwrite_phy(o_sens_w     ,sens_w     ) 
+       IF (vars_defined)  zx_tmp_fi2d(1:klon)=-1*sens_x(1:klon)
+               CALL histwrite_phy(o_sens_x     ,zx_tmp_fi2d) 
+       IF (vars_defined)  zx_tmp_fi2d(1:klon)=-1*sens_w(1:klon)
+               CALL histwrite_phy(o_sens_w     ,zx_tmp_fi2d) 
                CALL histwrite_phy(o_flat_x     ,zxfluxlat_x) 
                CALL histwrite_phy(o_flat_w     ,zxfluxlat_w) 
-               CALL histwrite_phy(o_delta_tsurf,delta_tsurf) 
+          zx_tmp_fi2d=0.
+          IF (vars_defined) THEN
+             DO nsrf=1,nbsrf
+                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:) &
+                        +pctsrf(:,nsrf)*delta_tsurf(:,nsrf)
+             ENDDO
+          ENDIF
+               CALL histwrite_phy(o_delta_tsurf,zx_tmp_fi2d) 
                CALL histwrite_phy(o_cdragh_x   ,cdragh_x   ) 
                CALL histwrite_phy(o_cdragh_w   ,cdragh_w   ) 
Index: /LMDZ6/trunk/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phys_state_var_mod.F90	(revision 3887)
+++ /LMDZ6/trunk/libf/phylmd/phys_state_var_mod.F90	(revision 3888)
@@ -32,4 +32,6 @@
       REAL, ALLOCATABLE, SAVE :: ftsol(:,:)
 !$OMP THREADPRIVATE(ftsol)
+      REAL, ALLOCATABLE, SAVE :: beta_aridity(:,:)
+!$OMP THREADPRIVATE(beta_aridity)
       REAL,ALLOCATABLE,SAVE :: qsol(:),fevap(:,:),z0m(:,:),z0h(:,:),agesno(:,:)
 !$OMP THREADPRIVATE(qsol,fevap,z0m,z0h,agesno)
@@ -96,8 +98,4 @@
       REAL, ALLOCATABLE, SAVE :: coefm(:,:,:) ! Kz momentum
 !$OMP THREADPRIVATE(pbl_tke, coefh,coefm)
-!nrlmd<
-      REAL, ALLOCATABLE, SAVE :: delta_tsurf(:,:) ! Surface temperature difference inside-outside cold pool
-!$OMP THREADPRIVATE(delta_tsurf)
-!>nrlmd
       REAL, ALLOCATABLE, SAVE :: zmax0(:), f0(:) ! 
 !$OMP THREADPRIVATE(zmax0,f0)
@@ -276,4 +274,8 @@
       REAL,ALLOCATABLE,SAVE :: wake_delta_pbl_TKE(:,:,:)
 !$OMP THREADPRIVATE(wake_delta_pbl_TKE)
+!nrlmd<
+      REAL, ALLOCATABLE, SAVE :: delta_tsurf(:,:) ! Surface temperature difference inside-outside cold pool
+!$OMP THREADPRIVATE(delta_tsurf)
+!>nrlmd
 !>jyg
 !
@@ -478,4 +480,5 @@
       ALLOCATE(pctsrf(klon,nbsrf))
       ALLOCATE(ftsol(klon,nbsrf))
+      ALLOCATE(beta_aridity(klon,nbsrf))
       ALLOCATE(qsol(klon),fevap(klon,nbsrf))
       ALLOCATE(z0m(klon,nbsrf+1),z0h(klon,nbsrf+1),agesno(klon,nbsrf))
@@ -674,4 +677,5 @@
 
       DEALLOCATE(pctsrf, ftsol, falb1, falb2)
+      DEALLOCATE(beta_aridity)
       DEALLOCATE(qsol,fevap,z0m,z0h,agesno)
 !FC
@@ -687,7 +691,4 @@
       DEALLOCATE(tr_ancien)                           !RomP
       DEALLOCATE(ratqs, pbl_tke,coefh,coefm)
-!nrlmd<
-      DEALLOCATE(delta_tsurf)
-!>nrlmd
       DEALLOCATE(zmax0, f0)
       DEALLOCATE(sig1, w01)
@@ -744,4 +745,7 @@
 !jyg<
       DEALLOCATE(wake_delta_pbl_TKE)
+!nrlmd<
+      DEALLOCATE(delta_tsurf)
+!>nrlmd
 !>jyg
       DEALLOCATE(pfrac_impa, pfrac_nucl)
Index: /LMDZ6/trunk/libf/phylmd/physiq_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 3887)
+++ /LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 3888)
@@ -210,4 +210,5 @@
        zxrunofflic,                            &
        zxtsol, snow_lsc, zxfqfonte, zxqsurf,   &
+       delta_qsurf,                            &
        rain_lsc, rain_num,                     &
        !
@@ -2485,5 +2486,6 @@
     !   s_therm,   s_trmb1,   s_trmb2, s_trmb3,
     !   zu10m,     zv10m,   fder,
-    !   zxqsurf,   rh2m,      zxfluxu, zxfluxv,
+    !   zxqsurf,   delta_qsurf,
+    !   rh2m,      zxfluxu, zxfluxv,
     !   frugs,     agesno,    fsollw,  fsolsw,
     !   d_ts,      fevap,     fluxlat, t2m,
@@ -2546,4 +2548,5 @@
                                 !albedo SB <<<
             cdragh,    cdragm,  u1,    v1,            &
+            beta_aridity, &
                                 !albedo SB >>>
                                 ! albsol1,   albsol2,   sens,    evap,      &
@@ -2572,5 +2575,5 @@
             s_therm,   s_trmb1,   s_trmb2, s_trmb3, &
             zustar, zu10m,     zv10m,   fder, &
-            zxqsurf,   rh2m,      zxfluxu, zxfluxv, &
+            zxqsurf, delta_qsurf,   rh2m,      zxfluxu, zxfluxv, &
             z0m, z0h,     agesno,    fsollw,  fsolsw, &
             d_ts,      fevap,     fluxlat, t2m, &
@@ -4637,5 +4640,8 @@
 
     CALL tend_to_tke(pdtphys,paprs,exner,t_seri,u_seri,v_seri,dtadd,duadd,dvadd,pctsrf,pbl_tke)
-
+   !
+   ! Prevent pbl_tke_w from becoming negative
+    wake_delta_pbl_tke(:,:,:) = max(wake_delta_pbl_tke(:,:,:), -pbl_tke(:,:,:))
+   !
 
        ENDIF
Index: /LMDZ6/trunk/libf/phylmd/wx_pbl_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/wx_pbl_mod.F90	(revision 3887)
+++ /LMDZ6/trunk/libf/phylmd/wx_pbl_mod.F90	(revision 3888)
@@ -1,9 +1,8 @@
 MODULE wx_pbl_mod
 !
-! Planetary Boundary Layer and Surface module
-!
-! This module manage the calculation of turbulent diffusion in the boundary layer 
-! and all interactions towards the differents sub-surfaces.
-!
+! Split Planetary Boundary Layer
+!
+! This module manages the splitting of the boundary layer between two regions; the (w) 
+! region (inside cold pools) and the (x) region (outside cold pools)
 !
   USE dimphy
@@ -11,130 +10,14 @@
   IMPLICIT NONE
 
-  REAL, ALLOCATABLE, DIMENSION(:), SAVE        :: Kech_Tp, Kech_T_xp, Kech_T_wp
-  REAL, ALLOCATABLE, DIMENSION(:), SAVE        :: dd_KTp, KxKwTp, dd_AT, dd_BT
-!$OMP THREADPRIVATE(Kech_Tp, Kech_T_xp, Kech_T_wp, dd_KTp, KxKwTp, dd_AT, dd_BT)
-  REAL, ALLOCATABLE, DIMENSION(:), SAVE        :: Kech_Qp, Kech_Q_xp, Kech_Q_wp
-  REAL, ALLOCATABLE, DIMENSION(:), SAVE        :: dd_KQp, KxKwQp, dd_AQ, dd_BQ
-!$OMP THREADPRIVATE(Kech_Qp, Kech_Q_xp, Kech_Q_wp, dd_KQp, KxKwQp, dd_AQ, dd_BQ)
-  REAL, ALLOCATABLE, DIMENSION(:), SAVE        :: Kech_Up, Kech_U_xp, Kech_U_wp
-  REAL, ALLOCATABLE, DIMENSION(:), SAVE        :: dd_KUp, KxKwUp, dd_AU, dd_BU
-!$OMP THREADPRIVATE(Kech_Up, Kech_U_xp, Kech_U_wp, dd_KUp, KxKwUp, dd_AU, dd_BU)
-  REAL, ALLOCATABLE, DIMENSION(:), SAVE        :: Kech_Vp, Kech_V_xp, Kech_V_wp
-  REAL, ALLOCATABLE, DIMENSION(:), SAVE        :: dd_KVp, KxKwVp, dd_AV, dd_BV
-!$OMP THREADPRIVATE(Kech_Vp, Kech_V_xp, Kech_V_wp, dd_KVp, KxKwVp, dd_AV, dd_BV)
-
 CONTAINS
 !
 !****************************************************************************************
 !
-SUBROUTINE wx_pbl_init
-
-! Local variables
-!****************************************************************************************
-    INTEGER                       :: ierr
- 
-
-!****************************************************************************************
-! Allocate module variables
-!
-!****************************************************************************************    
-
-    ierr = 0
-
-    ALLOCATE(Kech_Tp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(Kech_T_xp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(Kech_T_wp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(dd_KTp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(KxKwTp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(dd_AT(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(dd_BT(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-!----------------------------------------------------------------------------
-    ALLOCATE(Kech_Qp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(Kech_Q_xp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(Kech_Q_wp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(dd_KQp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(KxKwQp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(dd_AQ(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(dd_BQ(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-!----------------------------------------------------------------------------
-    ALLOCATE(Kech_Up(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(Kech_U_xp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(Kech_U_wp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(dd_KUp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(KxKwUp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(dd_AU(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(dd_BU(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-!----------------------------------------------------------------------------
-    ALLOCATE(Kech_Vp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(Kech_V_xp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(Kech_V_wp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(dd_KVp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(KxKwVp(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(dd_AV(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-    ALLOCATE(dd_BV(klon), stat=ierr)
-    IF (ierr /= 0) CALL abort_physic('wx_pbl_init', 'pb in allocation',1)
-
-!----------------------------------------------------------------------------
-
-END SUBROUTINE wx_pbl_init
-
-SUBROUTINE wx_pbl0_fuse(knon, dtime, ypplay, ywake_s, &
+SUBROUTINE wx_pbl0_merge(knon, ypplay, ypaprs,  &
+                                 sigw, dTs_forcing, dqs_forcing,  &
                                  yt_x, yt_w, yq_x, yq_w, &
                                  yu_x, yu_w, yv_x, yv_w, &
-                                 ycdragh_x, ycdragh_w, ycdragm_x, ycdragm_w, &
+                                 ycdragh_x, ycdragh_w, ycdragq_x, ycdragq_w, &
+                                 ycdragm_x, ycdragm_w, &
                                  AcoefT_x, AcoefT_w, AcoefQ_x, AcoefQ_w, &
                                  AcoefU_x, AcoefU_w, AcoefV_x, AcoefV_w, &
@@ -143,19 +26,29 @@
                                  AcoefT, AcoefQ, AcoefU, AcoefV, &
                                  BcoefT, BcoefQ, BcoefU, BcoefV, &
-                                 ycdragh, ycdragm, &
+                                 ycdragh, ycdragq, ycdragm, &
                                  yt1, yq1, yu1, yv1 &
                                  )
 !
+
+    USE wx_pbl_var_mod
+
     USE print_control_mod, ONLY: prt_level,lunout
+    USE indice_sol_mod, ONLY: is_oce
 !
     INCLUDE "YOMCST.h"
+    INCLUDE "FCTTRE.h"
+    INCLUDE "YOETHF.h"
+    INCLUDE "clesphys.h"
 !
     INTEGER,                      INTENT(IN)        :: knon    ! number of grid cells
-    REAL,                         INTENT(IN)        :: dtime   ! time step size (s)
     REAL, DIMENSION(knon,klev),   INTENT(IN)        :: ypplay  ! mid-layer pressure (Pa)
-    REAL, DIMENSION(knon),        INTENT(IN)        :: ywake_s ! cold pools fractional area
+    REAL, DIMENSION(knon,klev),   INTENT(IN)        :: ypaprs  ! pressure at layer interfaces (pa)
+    REAL, DIMENSION(knon),        INTENT(IN)        :: sigw ! cold pools fractional area
+    REAL, DIMENSION(knon),        INTENT(IN)        :: dTs_forcing ! forced temperature difference (w)-(x)
+    REAL, DIMENSION(knon),        INTENT(IN)        :: dqs_forcing ! forced humidity difference (w)-(x)
     REAL, DIMENSION(knon,klev),   INTENT(IN)        :: yt_x, yt_w, yq_x, yq_w
     REAL, DIMENSION(knon,klev),   INTENT(IN)        :: yu_x, yu_w, yv_x, yv_w
-    REAL, DIMENSION(knon),        INTENT(IN)        :: ycdragh_x, ycdragh_w, ycdragm_x, ycdragm_w
+    REAL, DIMENSION(knon),        INTENT(IN)        :: ycdragh_x, ycdragh_w, ycdragq_x, ycdragq_w
+    REAL, DIMENSION(knon),        INTENT(IN)        :: ycdragm_x, ycdragm_w
     REAL, DIMENSION(knon),        INTENT(IN)        :: AcoefT_x, AcoefT_w, AcoefQ_x, AcoefQ_w
     REAL, DIMENSION(knon),        INTENT(IN)        :: AcoefU_x, AcoefU_w, AcoefV_x, AcoefV_w
@@ -164,5 +57,5 @@
     REAL, DIMENSION(knon),        INTENT(OUT)       :: AcoefT, AcoefQ, AcoefU, AcoefV
     REAL, DIMENSION(knon),        INTENT(OUT)       :: BcoefT, BcoefQ, BcoefU, BcoefV
-    REAL, DIMENSION(knon),        INTENT(OUT)       :: ycdragh, ycdragm
+    REAL, DIMENSION(knon),        INTENT(OUT)       :: ycdragh, ycdragq, ycdragm
     REAL, DIMENSION(knon),        INTENT(OUT)       :: yt1, yq1, yu1, yv1  ! Apparent T, q, u, v at first level, as
                                                                            !seen by surface modules
@@ -170,10 +63,6 @@
 ! Local variables
     INTEGER                    :: j
-    REAL                       :: rho1
-    REAL                       :: mod_wind_x
-    REAL                       :: mod_wind_w   
-    REAL                       :: dd_Cdragh
-    REAL                       :: dd_Cdragm
     REAL                       :: dd_Kh
+    REAL                       :: dd_Kq
     REAL                       :: dd_Km
     REAL                       :: dd_u 
@@ -182,150 +71,79 @@
     REAL                       :: dd_q 
 !
-    REAL                       :: KCT, KCQ, KCU, KCV
-!
-    REAL                       :: BBT, BBQ, BBU, BBV
-    REAL                       :: DDT, DDQ, DDU, DDV
-    REAL                       :: LambdaT, LambdaQ, LambdaU, LambdaV 
     REAL                       :: LambdaTs, LambdaQs, LambdaUs, LambdaVs 
 !
     REAL, DIMENSION(knon)      :: sigx       ! fractional area of (x) region
-
-    REAL, DIMENSION(knon)      :: Kech_h    ! Energy exchange coefficient
-    REAL, DIMENSION(knon)      :: Kech_h_x, Kech_h_w
-    REAL, DIMENSION(knon)      :: Kech_m    ! Momentum exchange coefficient
-    REAL, DIMENSION(knon)      :: Kech_m_x, Kech_m_w
-
-!!!
-!!! jyg le 09/04/2013 ; passage aux nouvelles expressions en differences
-
-        sigx(:) = 1.-ywake_s(:)
-
+!
+!
+   sigx(1:knon) = 1.-sigw(1:knon)
+!                                           
+!
         DO j=1,knon
 !
-! Calcul des coefficients d echange
-         mod_wind_x = 1.0+SQRT(yu_x(j,1)**2+yv_x(j,1)**2)
-         mod_wind_w = 1.0+SQRT(yu_w(j,1)**2+yv_w(j,1)**2)
-!!         rho1 = ypplay(j,1)/(RD*yt(j,1))
-         rho1 = ypplay(j,1)/(RD*(yt_x(j,1) + ywake_s(j)*(yt_w(j,1)-yt_x(j,1))))
-         Kech_h_x(j) = ycdragh_x(j) * mod_wind_x * rho1
-         Kech_h_w(j) = ycdragh_w(j) * mod_wind_w * rho1
-         Kech_m_x(j) = ycdragm_x(j) * mod_wind_x * rho1
-         Kech_m_w(j) = ycdragm_w(j) * mod_wind_w * rho1
-!
-         dd_Kh = Kech_h_w(j) - Kech_h_x(j)
-         dd_Km = Kech_m_w(j) - Kech_m_x(j)
-         IF (prt_level >=10) THEN
-          print *,' mod_wind_x, mod_wind_w ', mod_wind_x, mod_wind_w
-          print *,' rho1 ',rho1
-          print *,' ycdragh_x(j),ycdragm_x(j) ',ycdragh_x(j),ycdragm_x(j)
-          print *,' ycdragh_w(j),ycdragm_w(j) ',ycdragh_w(j),ycdragm_w(j)
-          print *,' dd_Kh: ',dd_Kh
-         ENDIF
-!
-         Kech_h(j) = Kech_h_x(j) + ywake_s(j)*dd_Kh
-         Kech_m(j) = Kech_m_x(j) + ywake_s(j)*dd_Km
-!
-! Calcul des coefficients d echange corriges des retroactions
-        Kech_T_xp(j) = Kech_h_x(j)/(1.-BcoefT_x(j)*Kech_h_x(j)*dtime)
-        Kech_T_wp(j) = Kech_h_w(j)/(1.-BcoefT_w(j)*Kech_h_w(j)*dtime)
-        Kech_Q_xp(j) = Kech_h_x(j)/(1.-BcoefQ_x(j)*Kech_h_x(j)*dtime)
-        Kech_Q_wp(j) = Kech_h_w(j)/(1.-BcoefQ_w(j)*Kech_h_w(j)*dtime)
-        Kech_U_xp(j) = Kech_m_x(j)/(1.-BcoefU_x(j)*Kech_m_x(j)*dtime)
-        Kech_U_wp(j) = Kech_m_w(j)/(1.-BcoefU_w(j)*Kech_m_w(j)*dtime)
-        Kech_V_xp(j) = Kech_m_x(j)/(1.-BcoefV_x(j)*Kech_m_x(j)*dtime)
-        Kech_V_wp(j) = Kech_m_w(j)/(1.-BcoefV_w(j)*Kech_m_w(j)*dtime)
-!
-         dd_KTp(j) = Kech_T_wp(j) - Kech_T_xp(j)
-         dd_KQp(j) = Kech_Q_wp(j) - Kech_Q_xp(j)
-         dd_KUp(j) = Kech_U_wp(j) - Kech_U_xp(j)
-         dd_KVp(j) = Kech_V_wp(j) - Kech_V_xp(j)
-!
-        Kech_Tp(j) = Kech_T_xp(j) + ywake_s(j)*dd_KTp(j)
-        Kech_Qp(j) = Kech_Q_xp(j) + ywake_s(j)*dd_KQp(j)
-        Kech_Up(j) = Kech_U_xp(j) + ywake_s(j)*dd_KUp(j)
-        Kech_Vp(j) = Kech_V_xp(j) + ywake_s(j)*dd_KVp(j)
-!
-! Calcul des differences w-x
-       dd_Cdragm = ycdragm_w(j) - ycdragm_x(j)
-       dd_Cdragh = ycdragh_w(j) - ycdragh_x(j)
+!
+! Compute w-x differences
+       dd_t = yt_w(j,1) - yt_x(j,1)
+       dd_q = yq_w(j,1) - yq_x(j,1)
        dd_u = yu_w(j,1) - yu_x(j,1)
        dd_v = yv_w(j,1) - yv_x(j,1)
-       dd_t = yt_w(j,1) - yt_x(j,1)
-       dd_q = yq_w(j,1) - yq_x(j,1)
-       dd_AT(j) = AcoefT_w(j) - AcoefT_x(j)
-       dd_AQ(j) = AcoefQ_w(j) - AcoefQ_x(j)
-       dd_AU(j) = AcoefU_w(j) - AcoefU_x(j)
-       dd_AV(j) = AcoefV_w(j) - AcoefV_x(j)
-       dd_BT(j) = BcoefT_w(j) - BcoefT_x(j)
-       dd_BQ(j) = BcoefQ_w(j) - BcoefQ_x(j)
-       dd_BU(j) = BcoefU_w(j) - BcoefU_x(j)
-       dd_BV(j) = BcoefV_w(j) - BcoefV_x(j)
-!
-       KxKwTp(j) = Kech_T_xp(j)*Kech_T_wp(j)
-       KxKwQp(j) = Kech_Q_xp(j)*Kech_Q_wp(j)
-       KxKwUp(j) = Kech_U_xp(j)*Kech_U_wp(j)
-       KxKwVp(j) = Kech_V_xp(j)*Kech_V_wp(j)
-       BBT = (BcoefT_x(j) + sigx(j)*dd_BT(j))*dtime
-       BBQ = (BcoefQ_x(j) + sigx(j)*dd_BQ(j))*dtime
-       BBU = (BcoefU_x(j) + sigx(j)*dd_BU(j))*dtime
-       BBV = (BcoefV_x(j) + sigx(j)*dd_BV(j))*dtime
-       KCT = Kech_h(j)
-       KCQ = Kech_h(j)
-       KCU = Kech_m(j)
-       KCV = Kech_m(j)
-       DDT = Kech_Tp(j)
-       DDQ = Kech_Qp(j)
-       DDU = Kech_Up(j)
-       DDV = Kech_Vp(j)
-       LambdaT = dd_Kh/KCT
-       LambdaQ = dd_Kh/KCQ
-       LambdaU = dd_Km/KCU
-       LambdaV = dd_Km/KCV
-       LambdaTs = dd_KTp(j)/DDT
-       LambdaQs = dd_KQp(j)/DDQ
-       LambdaUs = dd_KUp(j)/DDU
-       LambdaVs = dd_KVp(j)/DDV
-!
-       IF (prt_level >=10) THEN
-          print *,'Variables pour la fusion : Kech_T_xp(j)' ,Kech_T_xp(j)
-          print *,'Variables pour la fusion : Kech_T_wp(j)' ,Kech_T_wp(j)
-          print *,'Variables pour la fusion : Kech_Tp(j)' ,Kech_Tp(j)
-          print *,'Variables pour la fusion : Kech_h(j)' ,Kech_h(j)
-       ENDIF
+!
+! Merged exchange coefficients
+         dd_Kh = Kech_h_w(j) - Kech_h_x(j)
+         dd_Kq = Kech_q_w(j) - Kech_q_x(j)
+         dd_Km = Kech_m_w(j) - Kech_m_x(j)
+!
+       LambdaTs = dd_KTp(j)/Kech_Tp(j)
+       LambdaQs = dd_KQs(j)/Kech_Qs(j)
+       LambdaUs = dd_KUp(j)/Kech_Up(j)
+       LambdaVs = dd_KVp(j)/Kech_Vp(j)
 !
 ! Calcul des coef A, B \'equivalents dans la couche 1
 !
-       AcoefT(j) = AcoefT_x(j) + ywake_s(j)*dd_AT(j)*(1.+sigx(j)*LambdaTs)
-       AcoefQ(j) = AcoefQ_x(j) + ywake_s(j)*dd_AQ(j)*(1.+sigx(j)*LambdaQs)
-       AcoefU(j) = AcoefU_x(j) + ywake_s(j)*dd_AU(j)*(1.+sigx(j)*LambdaUs)
-       AcoefV(j) = AcoefV_x(j) + ywake_s(j)*dd_AV(j)*(1.+sigx(j)*LambdaVs)
+! The dTs_forcing and dqs_forcing terms are added for diagnostic purpose ; they should be zero in normal operation.
+       AcoefT(j) = AcoefT_x(j) + sigw(j)*(1.+sigx(j)*LambdaTs)*(dd_AT(j) - C_p(j)*dTs_forcing(j))
+       AcoefQ(j) = AcoefQ_x(j) + sigw(j)*(1.+sigx(j)*LambdaQs)*(dd_AQ(j) - dqs_forcing(j))
+       AcoefU(j) = AcoefU_x(j) + sigw(j)*(1.+sigx(j)*LambdaUs)*dd_AU(j)
+       AcoefV(j) = AcoefV_x(j) + sigw(j)*(1.+sigx(j)*LambdaVs)*dd_AV(j)
 !                                           
-       BcoefT(j) = BcoefT_x(j) + ywake_s(j)*BcoefT_x(j)*sigx(j)*LambdaT*LambdaTs &
-                               + ywake_s(j)*dd_BT(j)*(1.+sigx(j)*LambdaT)*(1.+sigx(j)*LambdaTs)
-                                           
-       BcoefQ(j) = BcoefQ_x(j) + ywake_s(j)*BcoefQ_x(j)*sigx(j)*LambdaQ*LambdaQs &
-                               + ywake_s(j)*dd_BQ(j)*(1.+sigx(j)*LambdaQ)*(1.+sigx(j)*LambdaQs)
-                                           
-       BcoefU(j) = BcoefU_x(j) + ywake_s(j)*BcoefU_x(j)*sigx(j)*LambdaU*LambdaUs &
-                               + ywake_s(j)*dd_BU(j)*(1.+sigx(j)*LambdaU)*(1.+sigx(j)*LambdaUs)
-                                           
-       BcoefV(j) = BcoefV_x(j) + ywake_s(j)*BcoefV_x(j)*sigx(j)*LambdaV*LambdaVs &
-                               + ywake_s(j)*dd_BV(j)*(1.+sigx(j)*LambdaV)*(1.+sigx(j)*LambdaVs)
-
+!
+!!       BcoefT(j) = (sigw(j)*Kech_h_w(j)*Kech_T_pw(j)*BcoefT_w(j) + &
+!!                sigx(j)*Kech_h_x(j)*Kech_T_px(j)*BcoefT_x(j) )/(Kech_h(j)*Kech_Tp(j))
+!!       BcoefQ(j) = (sigw(j)*Kech_q_w(j)*Kech_Q_pw(j)*BcoefQ_w(j) + &
+!!                sigx(j)*Kech_q_x(j)*Kech_Q_px(j)*BcoefQ_x(j) )/(Kech_q(j)*Kech_Qp(j))
+!!       BcoefU(j) = (sigw(j)*Kech_m_w(j)*Kech_U_pw(j)*BcoefU_w(j) + &
+!!                sigx(j)*Kech_m_x(j)*Kech_U_px(j)*BcoefU_x(j) )/(Kech_m(j)*Kech_Up(j))
+!!       BcoefV(j) = (sigw(j)*Kech_m_w(j)*Kech_V_pw(j)*BcoefV_w(j) + &
+!!                sigx(j)*Kech_m_x(j)*Kech_V_px(j)*BcoefV_x(j) )/(Kech_m(j)*Kech_Vp(j))
+!
+!!  Print *,'YYYYpbl0: BcoefT_x, sigw, sigx, dd_Kh, dd_KTp, Kech_h_w ', &
+!!                     BcoefT_x, sigw, sigx, dd_Kh, dd_KTp, Kech_h_w
+!!  Print *,'YYYYpbl0: Kech_T_pw, dd_BT, Kech_h, Kech_Tp ', &
+!!                     Kech_T_pw, dd_BT, Kech_h, Kech_Tp
+       BcoefT(j) = BcoefT_x(j) + sigw(j)*(sigx(j)*dd_Kh*dd_KTp(j)*BcoefT_x(j) + &
+                                  Kech_h_w(j)*Kech_T_pw(j)*dd_BT(j))/(Kech_h(j)*Kech_Tp(j))
+       BcoefQ(j) = BcoefQ_x(j) + sigw(j)*(sigx(j)*dd_Kh*dd_KQs(j)*BcoefQ_x(j) + &
+                                  Kech_q_w(j)*Kech_Q_sw(j)*dd_BQ(j))/(Kech_q(j)*Kech_Qs(j))
+       BcoefU(j) = BcoefU_x(j) + sigw(j)*(sigx(j)*dd_Km*dd_KUp(j)*BcoefU_x(j) + &
+                                  Kech_m_w(j)*Kech_U_pw(j)*dd_BU(j))/(Kech_m(j)*Kech_Up(j))
+       BcoefV(j) = BcoefV_x(j) + sigw(j)*(sigx(j)*dd_Km*dd_KVp(j)*BcoefV_x(j) + &
+                                  Kech_m_w(j)*Kech_V_pw(j)*dd_BV(j))/(Kech_m(j)*Kech_Vp(j))
+!>jyg
+!
 !
 ! Calcul des cdrag \'equivalents dans la couche 
 !
-       ycdragm(j) = ycdragm_x(j) + ywake_s(j)*dd_Cdragm
-       ycdragh(j) = ycdragh_x(j) + ywake_s(j)*dd_Cdragh
+       ycdragm(j) = ycdragm_x(j) + sigw(j)*dd_Cdragm(j)
+       ycdragh(j) = ycdragh_x(j) + sigw(j)*dd_Cdragh(j)
+       ycdragq(j) = ycdragq_x(j) + sigw(j)*dd_Cdragq(j)
 !
 ! Calcul de T, q, u et v \'equivalents dans la couche 1
-!!       yt1(j) = yt_x(j,1) + ywake_s(j)*dd_t*(1.+sigx(j)*dd_Kh/KCT)
-!!       yq1(j) = yq_x(j,1) + ywake_s(j)*dd_q*(1.+sigx(j)*dd_Kh/KCQ)
-!!       yu1(j) = yu_x(j,1) + ywake_s(j)*dd_u*(1.+sigx(j)*dd_Km/KCU)
-!!       yv1(j) = yv_x(j,1) + ywake_s(j)*dd_v*(1.+sigx(j)*dd_Km/KCV)
-       yt1(j) = yt_x(j,1) + ywake_s(j)*dd_t
-       yq1(j) = yq_x(j,1) + ywake_s(j)*dd_q
-       yu1(j) = yu_x(j,1) + ywake_s(j)*dd_u
-       yv1(j) = yv_x(j,1) + ywake_s(j)*dd_v
+!!       yt1(j) = yt_x(j,1) + sigw(j)*dd_t*(1.+sigx(j)*dd_Kh/KCT)
+!!       yq1(j) = yq_x(j,1) + sigw(j)*dd_q*(1.+sigx(j)*dd_Kh/KCQ)
+!!       yu1(j) = yu_x(j,1) + sigw(j)*dd_u*(1.+sigx(j)*dd_Km/KCU)
+!!       yv1(j) = yv_x(j,1) + sigw(j)*dd_v*(1.+sigx(j)*dd_Km/KCV)
+       yt1(j) = yt_x(j,1) + sigw(j)*dd_t
+       yq1(j) = yq_x(j,1) + sigw(j)*dd_q
+       yu1(j) = yu_x(j,1) + sigw(j)*dd_u
+       yv1(j) = yv_x(j,1) + sigw(j)*dd_v
 
 
